#include <stdint.h>

#define I32 4294967296
#define I32M1 4294967295

class uint512_t {
	public:
		__device__ __host__ uint512_t(uint32_t n);
		__device__ __host__ uint512_t(uint32_t w0, uint32_t w1, uint32_t w2, uint32_t w3,
																  uint32_t w4, uint32_t w5, uint32_t w6, uint32_t w7,
																	uint32_t w8, uint32_t w9, uint32_t w10, uint32_t w11,
																	uint32_t w12, uint32_t w13, uint32_t w14, uint32_t w15); 
		__device__ __host__ uint512_t();
		__device__ __host__ uint512_t operator+(uint512_t a);
		__device__ __host__ uint512_t operator+(unsigned a);
		__device__ __host__ uint512_t operator-(uint512_t a);
		__device__ __host__ uint512_t operator-(unsigned a);
		__device__ __host__ uint512_t operator*(uint512_t a);
		__device__ __host__ uint512_t operator*(unsigned a);
		__device__ __host__ uint512_t operator/(uint32_t a);
		__device__ __host__ uint512_t operator/(uint512_t a);
		__device__ __host__ uint512_t operator%(uint512_t a);
		__device__ __host__ uint32_t operator%(unsigned a);
		__device__ __host__ bool operator>(uint512_t a);
		__device__ __host__ bool operator<(uint512_t a);
		__device__ __host__ bool operator==(uint512_t a);
		__device__ __host__ bool operator==(unsigned a);
		__device__ __host__ bool operator!=(uint512_t a);
		__device__ __host__ bool operator!=(unsigned a);
		__device__ __host__ uint512_t operator<<(uint32_t n);
		__device__ __host__ uint32_t to_uint32();
		__device__ __host__ int li();
  	uint32_t digits[16];
};

class uint128_t {
	public:
		__device__ __host__ uint128_t(uint32_t n);	
		__device__ __host__ uint128_t(uint32_t w0, uint32_t w1, uint32_t w2, uint32_t w3);
		__device__ __host__ uint128_t();
		__device__ __host__ uint128_t operator+(uint128_t a);
		__device__ __host__ uint128_t operator+(unsigned a);
		__device__ __host__ uint128_t operator-(uint128_t a);
		__device__ __host__ uint128_t operator-(unsigned a);
		__device__ __host__ uint128_t operator*(uint128_t a);
		__device__ __host__ uint128_t operator*(unsigned a);
		__device__ __host__ uint128_t operator/(unsigned a);
		__device__ __host__ uint128_t operator/(uint128_t a);
		__device__ __host__ uint128_t operator%(uint128_t a);
		__device__ __host__ uint32_t operator%(unsigned a);
		__device__ __host__ bool operator>(uint128_t a);
		__device__ __host__ bool operator<(uint128_t a);
		__device__ __host__ bool operator==(uint128_t a);
		__device__ __host__ bool operator==(unsigned a);
		__device__ __host__ bool operator!=(uint128_t a);
		__device__ __host__ bool operator!=(unsigned a);
		__device__ __host__ uint128_t operator<<(uint32_t n);
		__device__ __host__ uint32_t to_uint32();
		__device__ __host__ int li();
  	uint32_t digits[4];
};

__device__ __host__ uint512_t operator*(unsigned a, uint512_t b);
__device__ __host__ uint128_t operator*(unsigned a, uint128_t b);
__device__ __host__ uint512_t operator+(unsigned a, uint512_t b);
__device__ __host__ uint128_t operator+(unsigned a, uint128_t b);
